package com.school.project.controller.registration;


import com.school.project.dto.registrationDTO.StudentRegistrationDTO;
import com.school.project.dto.registrationDTO.TeacherRegistrationDTO;
import com.school.project.dto.registrationDTO.UserDTO;
import com.school.project.model.registration.Teacher;
import com.school.project.service.userRegistration.student.StudentRegistrationService;
import com.school.project.service.userRegistration.teacher.TeacherRegistrationService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.HttpStatus;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;
import org.springframework.web.server.ResponseStatusException;

@RestController
@RequestMapping("/register")
public class RegistrationController {

    @Autowired
    private StudentRegistrationService studentRegistrationService;

    @Autowired
    private TeacherRegistrationService teacherRegistrationService;

    @PostMapping("/student")
    public ResponseEntity<UserDTO> registerStudent(@RequestBody StudentRegistrationDTO student) {
        try {
            UserDTO userDTO = studentRegistrationService.registerStudent(student);
            return ResponseEntity.ok(userDTO);
        } catch (Exception e) {
            throw new ResponseStatusException(HttpStatus.BAD_REQUEST, "Data is not correct", e);
        }
    }

    @PostMapping("/teacher")
    public ResponseEntity<UserDTO> registerTeacher(@RequestBody TeacherRegistrationDTO teacher) {
        try {
            UserDTO userDTO = teacherRegistrationService.registerTeacher(teacher);
            return ResponseEntity.ok(userDTO);
        } catch (Exception e) {
            throw new ResponseStatusException(HttpStatus.BAD_REQUEST, "Data is not correct", e);
        }
    }
}
